



loglike.m4 = function(par) {
a1 = par[1]
a2 = par[2]
t0 = par[3]
b = par[4]

a = a1 * exp(-a2 / t0) - b * t0

t1 = t[t<=t0]
y1 = y[t<=t0]

t2 = t[t>t0]
y2 = y[t>t0]

m1 = a1*exp(-a2/t1)
m2 = a+b*t2

L1 = - sum((y1 - m1)^2)
L2 = - sum((y2 - m2)^2)

L = L1+L2
return(-L)
}

optim.m4 = optim(c(30,100,85, .008),loglike.m4, method="L-BFGS-B", lower=c(25, 95, 80, 0.004), upper=c(35, 110, 91, 0.150))


loglike.m1 = function(par) {
a1 = par[1]
a2 = par[2]

t1 = t
y1 = y

m1 = a1*exp(-a2/t1)

L1 = - sum((y1 - m1)^2)

L = L1
return(-L)
}

optim.m4 = optim(c(30,100,180, .008),loglike.m4, method="L-BFGS-B", lower=c(25, 95, 160, 0.004), upper=c(35, 110, 210, 0.150), hessian = TRUE)

optim.m1 = optim(c(30,100),loglike.m1, method="L-BFGS-B", lower=c(1, 10), upper=c(50, 150), hessian = TRUE)

a1.m1 = optim.m1$par[1]
a2.m1 = optim.m1$par[2]
m.m1 = a1.m1*exp(-a2.m1/t)
std.m1 = sqrt(1 / diag(optim.m1$hessian))
sigma.m1 = sum((y - m.m1)^2) / length(y)

a1.m4 = optim.m4$par[1]
a2.m4 = optim.m4$par[2]
t0.m4 = optim.m4$par[3]
b.m4 = optim.m4$par[4]
a.m4 = a1.m4 * exp(-a2.m4 / t0.m4) - b.m4 * t0.m4
t1 = t[t<=t0.m4]
y1 = y[t<=t0.m4]
t2 = t[t>t0.m4]
y2 = y[t>t0.m4]
m1.m4 = a1.m4*exp(-a2.m4/t1)
m2.m4 = a.m4+b.m4*t2

L1 = sum((y1 - m1.m4)^2)
L2 = sum((y2 - m2.m4)^2)
std.m4 = sqrt(1 / diag(optim.m4$hessian))
sigma.m4 = (L1 + L2) / length(y)


time.line = seq(2, 220, lenght = 1000)
y.line = a1.m1 * exp(-a2.m1 / time.line)

plot(t, y, col = "red", pch = 19)
points(time.line, y.line, col = "blue", type = "l")



