source("bayesian_func.R")
###odyssey code####
args<-commandArgs(TRUE)
ITER = as.integer(args)

alpha.upper = 35
alpha.lower = 25

beta.upper = 110
beta.lower = 100

t0.upper = 210
t0.lower = 1

b.upper = 0.012
b.lower = 0.006

alpha.mean = 30
alpha.sigma = 5

beta.mean = 105
beta.sigma = 10

t0.mean = 85
t0.sigma = 5

b.mean = .009
b.sigma = .001

alpha1 = 31
alpha2 = 104
t0 = 86
b = 0.009
delta.t0 = .4
delta.alpha1 = .2
delta.alpha2 = .5
delta.b = .0005

#####initial simulation part#####
alphaTrue<-31.68
betaTrue<-104.85
t0True<-90
bTrue = .009
sigmaTrue<-sqrt(0.086)
tmin = .5
tmax = 210
aTrue<-alphaTrue*exp(-betaTrue/t0True) - bTrue * t0True

generateTrue<-function(t){
#generate the output
	resid<-rnorm(1,0,sigmaTrue)
	truel<-ifelse(t<t0True,alphaTrue*exp(-betaTrue/t),aTrue + bTrue * t)
	return (truel+resid)
}
#this is the initial design part
N = 10
time.test = seq(2, 200, length = N)
y.test = array(NA, N)
for(i in 1:N){
	y.test[i] = generateTrue(time.test[i])
}

y = y.test
t = time.test



for(design.iter in 1:100){
#get the MLE estimation, for the initial points for MCMC
	source("MLE_code.R")
	#get the posterior draw
	posterior.sample = posterior.draw(a1.m4, a2.m4, t0.m4, b.m4, 10000)
	theta.2.sample = posterior.sample[[1]][(1:1000) * 10, ]
	sigma.2.sample = posterior.sample[[2]][(1:1000) * 10]
	NN = 1000
	nNew = 500
	candidate = seq(tmin, tmax, length = nNew)
	resultFinal = array(NA, nNew)
	for(k in 1:nNew){
		#iterate all the candidate points to find the determinant of the ifnomration matrix
		tdesignNew = c(t, candidate[k])
		result.temp = array(NA, NN)
		for(iter in 1:NN){
			aaa = det(informationMatrix.m4(theta.2.sample[iter, ], sigma.2.sample[iter], tdesignNew))
			result.00 = log(aaa)
			result.temp[iter] = result.00
		}
		resultFinal[k] = mean(result.temp, na.rm = T)
		print (k)
	}

	design.next = candidate[which(resultFinal == max(resultFinal))[1]]
	observation = generateTrue(design.next)
	y = c(y, observation)
	t = c(t, design.next)

}






